// ReplayMouseInSystem.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ReplayMouseInSystem.h"

#include <vector>
using namespace std;

typedef vector<POINT> (*MAFONCTION)();
vector<POINT> lespoints;

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_REPLAYMOUSEINSYSTEM, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_REPLAYMOUSEINSYSTEM));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_REPLAYMOUSEINSYSTEM));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_REPLAYMOUSEINSYSTEM);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	static UINT_PTR timer = 0;
	BOOL unhooked;
	static POINT pt; 
	FARPROC WINAPI HookAddr;
	static HHOOK HookHandle;
	static MAFONCTION MaFonction;
	HINSTANCE InstanceDll;
	static bool replay = false;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case ID_FILE_GO:
			// Installation du hook des vnements souris
			// D'abord charger la Dll contenant
			// la procdure de hook
			InstanceDll = LoadLibrary(L"ReplayMouseInSystemDll.dll");
			if(InstanceDll == NULL)
			{
				MessageBox(hWnd, L"Oups dll", L"Oups!", MB_OK);
				PostQuitMessage(0);
				break;
			}
			// Puis charger les fonctions
			// Dabord la fonction qui rcupre les points
			MaFonction = reinterpret_cast<MAFONCTION>(GetProcAddress(InstanceDll, "GetHookedPoints"));
			if(MaFonction == NULL)
			{
				MessageBox(hWnd, L"Oups MaFonction", L"Oups!", MB_OK);
				PostQuitMessage(0);
				break;
			}

			// Puis la fonction de hook
			HookAddr = GetProcAddress(InstanceDll, "MaLowLevelMouseProc");
			if(HookAddr == NULL)
			{
				GetLastError();
				MessageBox(hWnd, L"Oups hook addr", L"Oups!", MB_OK);
				PostQuitMessage(0);
				break;
			}
			// Installation du hook proprement dite
			HookHandle = SetWindowsHookEx(WH_MOUSE_LL,
				reinterpret_cast<HOOKPROC>(HookAddr),
						InstanceDll, NULL);

			if(HookHandle == NULL)
			{
				MessageBox(hWnd, L"Oups hook", L"Oups!", MB_OK);
				PostQuitMessage(0);
			}

			// Dmarrer le timer
			timer = SetTimer(hWnd, 1000, 3000, NULL);
			if(timer ==0)
			{
				MessageBox(hWnd, L"Oups timer", L"Oups!", MB_OK);
				PostQuitMessage(0);
			}
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_TIMER:
		// Arrter le timer
		KillTimer(hWnd, timer);
		// Enlever le hook
		unhooked = UnhookWindowsHookEx(HookHandle);
		if(!unhooked)
		{
			MessageBox(hWnd, L"Oups Unhook", L"Oups!", MB_OK);
			PostQuitMessage(0);
			break;
		}
		// et maintenant on rcupre les vnement WM_MOUSEMOVE
		// puis on les rejoue dans notre fentre
		lespoints = MaFonction();
		replay = true;
		for(vector<POINT>::iterator it = lespoints.begin(); it!=lespoints.end(); ++it)
		{
			SendMessage(hWnd, WM_MOUSEMOVE, 0, MAKELPARAM((*it).x, (*it).y));
		}
		replay = false;
		break;
	case WM_MOUSEMOVE:
		if(!replay)
			break;
		hdc = GetDC(hWnd); 
        MoveToEx(hdc, pt.x, pt.y, NULL); 
        LineTo(hdc, pt.x = LOWORD(lParam), 
          pt.y = HIWORD(lParam)); 
        ReleaseDC(hWnd, hdc); 
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
